<script setup lang="ts">
import { useJoueurStore } from '@/stores/joueur'
import { usePartieStore } from '@/stores/partie'
import { usePlaylistStore } from '@/stores/playlist'
import { useTagStore } from '@/stores/tag'
import type { Partie, RefPlaylist, UpdatePartie } from '@/types/partieDto'
import { optionsPresets } from '@/types/partieDto'
import { hashs } from '@/utils/hash'
import { QuestionMarkCircleIcon } from '@heroicons/vue/24/outline'
import { debounce } from 'lodash'
import { computed, onMounted, ref, watch, type Ref } from 'vue'

const emit = defineEmits<{
  updatePartie: [updatePartie: UpdatePartie]
  startPartie: []
}>()

const partieStore = usePartieStore()
const joueurStore = useJoueurStore()
const playlistStore = usePlaylistStore()
const tagStore = useTagStore()

const maxChansonsFromRefPlaylist = (rp?: RefPlaylist) => {
  if (rp) {
    if ('id' in rp) {
      return playlistStore.playlistsAsMap.get(rp.id)?.chansons?.length
    } else {
      return playlistStore.dynamicPlaylists.find(
        (dp) => dp.idTag === rp.id_tag && dp.valeurTag === rp.valeur_tag
      )?.chansons?.length
    }
  } else {
    return undefined
  }
}

const presetFromPartie = (partie: Partie | null) => {
  return (
    Array.from(optionsPresets.values()).find((p) => {
      const toggles = p.toggles
      if (partie) {
        return (
          partie.checkText === toggles.checkText &&
          partie.buzzer === toggles.buzzer &&
          partie.modeBlitz === toggles.modeBlitz &&
          partie.checkAll === toggles.checkAll
        )
      } else {
        return false
      }
    }) ?? optionsPresets.get('VOCAL')!!
  )
}

const refsPlaylist: Ref<{ id: number; nom: string; ref: RefPlaylist }[]> = ref([])

const refPlaylist = ref(partieStore.partie?.refPlaylist)
const maxNbManches = computed(() => maxChansonsFromRefPlaylist(refPlaylist.value))
const nbManches = ref(partieStore.partie?.nombreManches)
const preset = ref(presetFromPartie(partieStore.partie))

const updateDataFromPartie = (partie: Partie | null) => {
  if (partie) {
    refPlaylist.value = partie.refPlaylist
    nbManches.value = partie.nombreManches
    preset.value = presetFromPartie(partie)

    if (
      joueurStore.currentJoueur!!.id === partie.participants.find((p) => p.maitreJoueur)!!.refJoueur
    ) {
      // si je suis le maitre joueur
      refsPlaylist.value = playlistStore.playlists
        .map((p) => {
          return {
            id: p.id,
            nom: p.nom,
            ref: { id: p.id } as RefPlaylist
          }
        })
        .concat(
          playlistStore.dynamicPlaylists.map((p) => {
            return {
              id: hashs([p.idTag, p.valeurTag]),
              nom:
                `${tagStore.tagsAsMap.get(p.idTag)?.nom} ${p.valeurTag ?? ''}`.trim() +
                ' (Dynamique)',
              ref: {
                id_tag: p.idTag,
                id_joueur: joueurStore.currentJoueur!!.id,
                valeur_tag: p.valeurTag
              }
            }
          })
        )
    } else {
      // si je suis un participant lambda
      const playlistSuffix = 'id' in partie.refPlaylist ? '' : ' (Dynamique)'
      const playlistId = 'id' in partie.refPlaylist ? partie.refPlaylist.id : 1
      refsPlaylist.value = [
        { id: playlistId, nom: partie.nomPlaylist + playlistSuffix, ref: partie.refPlaylist }
      ]
    }
  } else {
    console.log('Not loaded !')
  }
}

onMounted(() => {
  updateDataFromPartie(partieStore.partie)
})

watch(
  () => partieStore.partie,
  (next) => {
    updateDataFromPartie(next)
  }
)

const getJoueurById = (id: number) => joueurStore.joueurs.find((j) => j.id === id)
const amIAStandardContestant = () =>
  joueurStore.currentJoueur!!.id !==
  partieStore.partie!!.participants.find((p) => p.maitreJoueur)!!.refJoueur

const updateRefPlaylist = debounce(() => {
  emit('updatePartie', { refPlaylist: refPlaylist.value })
}, 500)

const updateNbManches = debounce(() => {
  emit('updatePartie', { nombreManches: nbManches.value })
}, 500)

const updatePreset = debounce(() => {
  emit('updatePartie', { ...preset.value.toggles })
}, 500)

const startPartie = () => {
  emit('startPartie')
}
</script>

<template>
  <div v-if="partieStore.partie" class="flex gap-4 ml-4 mr-4 flex-col items-center sm:flex-row sm:items-stretch">
    <div class="flex-grow">
      <div>
        <label for="playlist" class="label"><span class="label-text">Playlist : </span></label>
        <select id="playlist" class="select select-bordered" v-model="refPlaylist" @change="updateRefPlaylist"
          :disabled="amIAStandardContestant()">
          <option v-for="pl in refsPlaylist" :key="pl.id" :value="pl.ref">
            {{ pl.nom }}
          </option>
        </select>
      </div>
      <div>
        <label for="nb-manches" class="label"><span class="label-text">Nombre de manches : </span></label>
        <input id="nb-manches" class="input input-bordered" type="number" min="1" :max="maxNbManches" v-model="nbManches"
          :disabled="amIAStandardContestant()" @input="updateNbManches" />
      </div>
      <div>
        <label for="preset" class="label"><span class="label-text">Preset : </span></label>
        <select id="preset" class="select select-bordered" v-model="preset" @change="updatePreset"
          :disabled="amIAStandardContestant()">
          <option v-for="entry in optionsPresets" :key="entry[0]" :value="entry[1]" :selected="preset.name === entry[0]">
            {{ entry[1].label }}
          </option>
        </select>
      </div>

      <div class="divider"></div>

      <div>
        <label for="check-text" class="label"><span class="label-text">Vérification du texte : </span></label>
        <input id="check-text" class="toggle toggle-lg" disabled type="checkbox" :checked="preset.toggles.checkText" />
      </div>
      <div>
        <label for="buzzer" class="label"><span class="label-text">Buzzer : </span></label>
        <input id="buzzer" class="toggle toggle-lg" disabled type="checkbox" :checked="preset.toggles.buzzer" />
      </div>
      <div>
        <label for="blitz" class="label flex gap-1 items-center justify-start">
          <span class="label-text"> Mode blitz : </span>
          <div class="tooltip tooltip-right w-4" data-tip="Le plus rapide à trouver met fin à la manche">
            <QuestionMarkCircleIcon />
          </div>
        </label>
        <input id="blitz" class="toggle toggle-lg" disabled type="checkbox" :checked="preset.toggles.modeBlitz" />
      </div>
      <div>
        <label for="check-all" class="label flex gap-1 items-center justify-start">
          <span class="label-text">Tout vérifier : </span>
          <div class="tooltip tooltip-right w-4"
            data-tip="Toutes les informations du titre sont vérifiées (le titre, l'artiste, les valeurs de tags, etc.)">
            <QuestionMarkCircleIcon />
          </div>
        </label>
        <input id="check-all" class="toggle toggle-lg" disabled type="checkbox" :checked="preset.toggles.checkAll" />
      </div>
    </div>

    <div class="flex-shrink card w-64 bg-base-100 shadow-xl">
      <div class="card-body">
        <h3 class="card-title">Joueurs</h3>
        <ul v-for="p in partieStore.partie.participants" :key="p.refJoueur">
          <li>
            <span v-if="p.maitreJoueur">👑</span>
            <span>{{ getJoueurById(p.refJoueur)?.login }}</span>
          </li>
        </ul>
      </div>
    </div>
  </div>

  <button v-if="partieStore.partie && partieStore.partie.etat === 'OPENED' && !amIAStandardContestant()"
    class="btn btn-info mt-auto ml-4 mr-4" @click="startPartie">
    Lancer la partie !
  </button>
</template>
